﻿using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Interactivity;

namespace MasterDetailsViewDemo
{
    public class SelectionBehaviour : Behavior<SfDataGrid>
    {
        public object DetailsViewSelectedItem
        {
            get { return (object)GetValue(DetailsViewSelectedItemProperty); }
            set { SetValue(DetailsViewSelectedItemProperty, value); }
        }

        public static readonly DependencyProperty DetailsViewSelectedItemProperty =
            DependencyProperty.Register("DetailsViewSelectedItem", typeof(object), typeof(SelectionBehaviour), new PropertyMetadata(null));

        public object DetailsViewCurrentItem
        {
            get { return (object)GetValue(DetailsViewCurrentItemProperty); }
            set { SetValue(DetailsViewCurrentItemProperty, value); }
        }
        public static readonly DependencyProperty DetailsViewCurrentItemProperty =
           DependencyProperty.Register("DetailsViewCurrentItem", typeof(object), typeof(SelectionBehaviour), new PropertyMetadata(null));
        
        public ObservableCollection<object> DetailsViewSelectedItems
        {
            get { return (ObservableCollection<object>)GetValue(DetailsViewSelectedItemsProperty); }
            set { SetValue(DetailsViewSelectedItemsProperty, value); }
        }

        public static readonly DependencyProperty DetailsViewSelectedItemsProperty =
            DependencyProperty.Register("DetailsViewSelectedItems", typeof(ObservableCollection<object>), typeof(SelectionBehaviour), new PropertyMetadata(null));

        protected override void OnAttached()
        {
            base.OnAttached();
            this.AssociatedObject.Loaded += AssociatedObject_Loaded;
        }

        void AssociatedObject_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            (this.AssociatedObject.DetailsViewDefinition[0] as GridViewDefinition).DataGrid.SelectionChanged += FirstDetailsViewDataGridSelectionChanged;
           
            this.AssociatedObject.View.CurrentChanged += View_CurrentChanged;
            
        }
        public Object ViewCurrentItem
        {
            get { return (Object)GetValue(ViewCurrentItemProperty); }
            set { SetValue(ViewCurrentItemProperty, value); }
        }

        public static readonly DependencyProperty ViewCurrentItemProperty =
            DependencyProperty.Register("ViewCurrentItem", typeof(Object), typeof(SelectionBehaviour), new PropertyMetadata(null));

        void View_CurrentChanged(object sender, EventArgs e)
        {
            this.ViewCurrentItem = this.AssociatedObject.View.CurrentItem;
        }
        void FirstDetailsViewDataGridSelectionChanged(object sender, GridSelectionChangedEventArgs e)
        {
            var OrderDetailCollection = this.AssociatedObject.DataContext as ViewModel;

            var CurrentItemDetails = OrderDetailCollection.OrdersDetails[2].OrderDetails[0] as OrderDetails;
            var SelectedItemDetails = OrderDetailCollection.OrdersDetails[3].OrderDetails[0] as OrderDetails;

            //Set the Specific OrderDetails to the CurrentItem/SelectedItem
            (e.OriginalSender as SfDataGrid).CurrentItem = CurrentItemDetails;
            (e.OriginalSender as SfDataGrid).SelectedItem = SelectedItemDetails;

            this.DetailsViewSelectedItem = (e.OriginalSender as SfDataGrid).SelectedItem;
           
            this.DetailsViewSelectedItems = (e.OriginalSender as SfDataGrid).SelectedItems;
           
            this.DetailsViewCurrentItem = (e.OriginalSender as SfDataGrid).CurrentItem;
       }
    }
}
