#region Copyright Syncfusion Inc. 2001 - 2014
// Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace MasterDetailsViewDemo
{
    public class ViewModel : INotifyPropertyChanged
    {
        private object _selectedFirstGridItem;
        private ObservableCollection<object> firstNestedGridSelectedItems;        
        private object firstNestedCurrentDetails;
        /// <summary>
        /// Initializes a new instance of the <see cref="ViewModel"/> class.
        /// </summary>
        public ViewModel()
        {
            OrderInfoRepository order = new OrderInfoRepository();
            OrdersDetails = order.GetOrdersDetails(20);
        }

        public List<OrderInfo> _ordersDetails;

        /// <summary>
        /// Gets or sets the orders details.
        /// </summary>
        /// <value>The orders details.</value>
        public List<OrderInfo> OrdersDetails
        {
            get { return _ordersDetails; }
            set { _ordersDetails = value; }
        }
        public object SelectedFirstNestedGridOrderDetails
        {
            get
            {
                return this._selectedFirstGridItem;
            }
            set
            {
                this._selectedFirstGridItem = value;
                this.RaisePropertyChanged("SelectedFirstNestedGridOrderDetails");
            }
        }
        public object FirstNestedCurrentDetails
        {
            get
            {
                return this.firstNestedCurrentDetails;
            }
            set
            {
                this.firstNestedCurrentDetails = value;
                RaisePropertyChanged("FirstNestedCurrentDetails");
            }
        }
        public ObservableCollection<object> FirstNestedGridSelectedItems
        {
            get
            {
                return this.firstNestedGridSelectedItems;
            }
            set
            {
                this.firstNestedGridSelectedItems = value;
                RaisePropertyChanged("FirstNestedGridSelectedItems");
            }
        }
        public void RaisePropertyChanged(string propName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
